//! Authentication  reslated struct definitions

/// User identifier. 16 bytes for easy uuid conversion
#[derive(Debug, Copy, Clone)]
pub struct UserID([u8; 16]);

impl From<[u8; 16]> for UserID {
    fn from(raw: [u8; 16]) -> Self {
        UserID(raw)
    }
}

impl UserID {
    /// length of the User ID in bytes
    pub const fn len() -> usize {
        16
    }
}
/// Authentication Token, basically just 32 random bytes
#[derive(Copy, Clone)]
pub struct Token([u8; 32]);

impl Token {
    /// length of the token in bytes
    pub const fn len() -> usize {
        32
    }
}

impl From<[u8; 32]> for Token {
    fn from(raw: [u8; 32]) -> Self {
        Token(raw)
    }
}

// Fake debug implementation to avoid leaking tokens
impl ::core::fmt::Debug for Token {
    fn fmt(
        &self,
        f: &mut core::fmt::Formatter<'_>,
    ) -> Result<(), ::std::fmt::Error> {
        ::core::fmt::Debug::fmt("[hidden token]", f)
    }
}
